#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "common.h"

void double_size(char **oldbuf, int *bufsize) {
	char *newbuf;
	debug("Old buffer size: %d", (*bufsize));
	(*bufsize) *= 2;
	newbuf = calloc((*bufsize), sizeof(char));
	if (!newbuf) { perror("calloc"); abort(); }
	strcpy(newbuf, *oldbuf);
	free(*oldbuf);
	(*oldbuf) = newbuf;
	debug("Doubled size: %d bytes", *bufsize);
}	

char *subst_change_cmd(char *change_cmd) {
	char *sub_id = (id == NULL ? "" : id);
	char *sub_mode = (mode == MODE_WRITE ? "w" : "r");
	char *sub_tapeno, *sub_bytes_tape, *sub_bytes_total;
	char *c, *s, *a;
	char *cmdbuf;
	int bufsize = 64;
	int b = 0;

	cmdbuf = calloc(bufsize, sizeof(char));

	asprintf(&sub_tapeno, "%d", tapeno);
	asprintf(&sub_bytes_tape, "%d", bytes_tape);
	asprintf(&sub_bytes_total, "%d", bytes_total);
	
	c = change_cmd;
	while ((s = (char*)strchr(c, '%'))) {
		if (s != c) {
			if (bufsize < (b + s-c + 1))
				double_size(&cmdbuf, &bufsize);
			strncat(cmdbuf+b, c, s-c);
			b += s-c;
		}
		switch (*(s+1)) {
			case 'm': a = sub_mode; break;
			case 'i': a = sub_id; break;
			case 'n': a = sub_tapeno; break;
			case 'b': a = sub_bytes_tape; break;
			case 'B': a = sub_bytes_total; break;
			case '%': a = "%"; break;
			case '\0':
				warning("Pojedynczy znak %% na kocu polecenia. Podstawiam %%");
				a = "%"; break;
			default:
				warning("Niezdefiniowane podstawienie: %c."
					" Podstawiam pusty cig", *(s+1));
				a = ""; break;
		}
		if (bufsize < (b + strlen(a) + 1))
			double_size(&cmdbuf, &bufsize);
		strcat(cmdbuf+b, a);
		b += strlen(a);
		if (*(s+1)) c = s+2; else c = s+1;
	}	
	if (strlen(c)) {
		if (bufsize < b + strlen(c) + 1)
			double_size(&cmdbuf, &bufsize);
		strcat(cmdbuf+b, c);
		b += strlen(c);
	}
	return cmdbuf;
}

void tape_stats() {
	notice("tape %d: %d bytes / %d blocks of backup in %ld seconds",
		tapeno, bytes_tape, blocks_tape, time(NULL) - tape_start_time);
}

int change_tape() {
	// kody wyjcia: 0 - lecimy dalej , 1 - koniec backupu
	if (change_cmd) {
		char *s;
		int i;
		debug("Zmiana tasmy: change_cmd: %s", change_cmd);
		s = subst_change_cmd(change_cmd);
		debug("Zmiana tasmy: wykonuj: %s", s);
		i = system(s) >> 8;
		free(s);
		debug("Zmiana tasmy: status %d", i);
		if (i < 0) { perror("system"); abort(); }
		else if (i == 0) {
			debug("Zmiana tasmy: OK");
			return 0;
		} else if ((i == 1) && (mode == MODE_READ)) {
			notice("Zmiana tasmy: OK, koniec backupu");
			return 1;
		} else error("Zmiana tasmy: status %d", i);
	}
	return 0;
}

void koniec_backupu() {
	tape_stats();
	if (change_after_last) {
		debug("Jeszcze ostatnia zmiana tamy na koniec");
		tapeno = 0;
		change_tape();
	}
	notice("total: %d bytes / %d blocks %s %d tapes in %ld seconds",
		bytes_total, blocks_total,
		(mode == MODE_READ ? "read from" : "written on"),
		tapeno, time(NULL) - start_time);
	exit(0);
}

void close_tape_dev() {
	debug("Closing tape device: %s", tape_dev);
	if (close(tape_fd) < 0) { perror("close"); abort(); }
}
	
void open_tape_dev() {
	debug("Opening tape device: %s", tape_dev);
	tape_fd = open(tape_dev, (mode == MODE_READ ? O_RDONLY : O_WRONLY));
	if (tape_fd < 0) { perror("open"); abort(); }
}

