#ifndef _COMMON_H_
#define _COMMON_H_

#include <stdio.h>
#include <time.h>

#define MODE_READ 1
#define MODE_WRITE 2

#define notice(x, args...) { fprintf(stderr, x, ## args); fprintf(stderr, "\n"); fflush(stderr); }
#define warning(x, args...) { fprintf(stderr, "WARNING: "); notice(x, ## args); }
#define error_msg(x, args...) { fprintf(stderr, "ERROR: "); notice(x, ## args); }
#define error(x, args...) { error_msg(x, ## args); abort(); }
#define debug(x, args...) { if (debugging) { fprintf(stderr, "DEBUG: "); notice(x, ## args); }}

extern char *change_cmd;
extern char *id;
extern int mode;
extern int blocksize;
extern int defvarreadblocksize;
extern int defvarwriteblocksize;
// extern int max_read;
extern int max_tapes;
extern int tape_size;
extern int tag_tapes;
extern int tag_end;
extern int change_before_first;
extern int change_after_last;
extern int tapeno;
extern int bytes_tape;
extern int bytes_total;
extern int blocks_tape;
extern int blocks_total;
extern char *tape_dev;
extern int tape_fd;
extern int drive_mode; // 0 - variable
extern int debugging;
extern time_t start_time;
extern time_t tape_start_time;
extern int extfd;
#endif
