#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <string.h>
#include <ctype.h>


#include "id.h"
#include "common.h"

int id_size = 16;

char *losuj_id() {
	char *wynik, *p;
	int i, j;
	struct timeval tv;

	wynik = calloc(id_size + 1, sizeof(char));
	if (!wynik) { perror("calloc"); abort(); }
	p = wynik;

	if (gettimeofday(&tv, NULL) < 0) { perror("gettimeofday"); abort(); }
	srand(tv.tv_usec);
	for (i = 0; i < id_size; i++) {
		j = (int)(16.0 * rand()/(RAND_MAX+1.0));
		sprintf(p++, "%x", j);
	}
	return wynik;
}
	
char *get_backup_id(char *arg) {
	char *ret, *spac, *tag;
	tag = (char*)strdup(arg);
	if (!tag) { perror("strdup"); abort(); }
	if (strncmp("BACKUP ", tag, 7))
		error("Wczytany blok nie ma odpowiedniej struktury");
	tag += 7;
	spac = (char*)strchr(tag, ' ');
	if (!spac)
		error("Wczytany blok nie ma odpowiedniej struktury");
	*spac = '\0';
	ret = (char*)strdup(tag);
	if (!ret) { perror("strdup"); abort(); }
	*spac = ' ';
	debug("Znalazem id: %s", ret);
	return ret;
}
		
int set_backup_id(char *tag) {
	char *noweid;
	int len;
	noweid = NULL;
	asprintf(&noweid, "BACKUP %s TAPE %d", id, tapeno);
	debug("Wygenerowane id: %s", noweid);
	len = strlen(noweid);
	if (len > blocksize-1) error("strlen(ID) > blocksize");
	strcpy(tag, noweid);
	return len;
}

int set_backup_end(char *tag) {
	char *noweid;
	int len;
	noweid = NULL;
	asprintf(&noweid, "BACKUP %s EOD", id);
	debug("Wygenerowany end: %s", noweid);
	len = strlen(noweid);
	if (len > blocksize-1) error("strlen(EOD) > blocksize");
	strcpy(tag, noweid);
	return len;
}

void check_backup_id(char *tag, int len) {
	char *oczekiwany;

	asprintf(&oczekiwany, "BACKUP %s TAPE %d", id, tapeno);
	debug("check_backup_id: Oczekiwane id: %s", oczekiwany);
	if (strlen(oczekiwany) != len) {
		error_msg("Oczekiwane id: BACKUP %s TAPE %d", id, tapeno);
		error("Wczytane id jest innej dugoci ni oczekiwane");
	}
	if (strncmp(oczekiwany, tag, len)) {
		char *i;
		for (i = tag; *i; i++)
			if (!isalnum(*i)&&!isspace(*i)) {
				error_msg("Oczekiwane id: BACKUP %s TAPE %d",
					id, tapeno);
				error("Wczytane id nietekstowe");
			}
		error_msg("Oczekiwane id: BACKUP %s TAPE %d", id, tapeno);
		error("Wczytane id: %s", tag);
	}	
	debug("check_backup_id: OK");
}

void check_backup_end(char *tag, int len) {
	char *oczekiwany;

	asprintf(&oczekiwany, "BACKUP %s EOD", id);
	debug("check_backup_end: Oczekiwane id: %s", oczekiwany);
	if (strlen(oczekiwany) != len) {
		error_msg("Oczekiwane id: BACKUP %s TAPE %d", id, tapeno);
		error("Wczytane id jest innej dugoci ni oczekiwane");
	}
	if (strncmp(oczekiwany, tag, len)) {
		char *i;
		for (i = tag; *i; i++)
			if (!isalnum(*i)&&!isspace(*i)) {
				error_msg("Oczekiwane id: BACKUP %s EOD", id);
				error("Wczytane id nietekstowe");
			}
		error_msg("Oczekiwane id: BACKUP %s EOD", id);
		error("Wczytane id: %s", tag);
	}	
	debug("check_backup_id: OK");
}
