#include <string.h>
#include <sys/mtio.h>
#include "common.h"

void check_drive_mode() {
	struct mtget mtstatus;
	if (ioctl(tape_fd, MTIOCGET, &mtstatus) < 0) {
		perror("ioctl"); abort();
	}
	drive_mode = (mtstatus.mt_dsreg & MT_ST_BLKSIZE_MASK) >> MT_ST_BLKSIZE_SHIFT;
	debug("Drive block size: %d", drive_mode);
	if ((blocksize == 0) && (drive_mode == 0)) {
		blocksize = (mode == MODE_READ ? defvarreadblocksize : defvarwriteblocksize);
		notice("Setting default %s block size: %d",
				(mode == MODE_READ ? "read" : "write"),
				blocksize);
	} else if (blocksize == 0) {
		notice("Settint block size based on drive settings: %d", drive_mode);
		blocksize = drive_mode;
	} else if ((drive_mode > 0) && (blocksize > 0)) 
		warning("blocksize (%d) != drive blocksize (%d)",
			blocksize, drive_mode);
}

void write_eof() {
	struct mtop mt_cmd;
	mt_cmd.mt_op = MTWEOF;
	mt_cmd.mt_count = 1;
	if (ioctl(tape_fd, MTIOCTOP, &mt_cmd) < 0) {
		perror("ioctl"); abort();
	}
}

