#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "change_tape.h"
#include "readwrite.h"
#include "id.h"
#include "mode.h"

void do_read() {
	char *tagbuf = NULL;
	block_stat b;

	while (1) {
		open_tape_dev();
		check_drive_mode();
		if (tag_tapes) {
			int x;
			if (!tagbuf) tagbuf = (char *)malloc(blocksize);
			b = read_block(tagbuf, 1);
			if (b.len == 0)
				error("Od razu napotkalem EOF - brak ID");
			if (!id) id = get_backup_id(tagbuf);
			check_backup_id(tagbuf, b.len);
			while (1) {
				x = 1;
				b = read_block(tagbuf, 1);
				if (b.len > 0) x++;
				else {
					if (x > 1) warning("Za maly blocksize - pocztkowy tag ma %d blokw zamiast 1.", x);
					break;
				}
			}
		}
		read_tape();
		debug("Spodziewam si e jest END albo koniec tamy");
		b = read_block(tagbuf, 1);
		if ((b.len > 0) && tag_end) {
			debug("Wczytany blok kocowy?");
			check_backup_end(tagbuf, b.len);
			debug("Zgadza sie");
			koniec_backupu();
		} else if (b.len > 0) {
			// heurystyka - jeli nie tagujemy kocw backupu,
			// a skoczy nam si plik i jest za nim dalej co zapisane
			// to to jest koniec backupu
			debug("Koniec pliku, dalej co jest zapisane, a my nie oczekujemy END");
			koniec_backupu();
		}
		// ret == 0 - znaczy e EOD (podwjny read = 0)
		if (max_tapes && (tapeno >= max_tapes)) {
			debug("Osignity limit tam");
			koniec_backupu();
		}
		close_tape_dev();
		tape_stats();
		tapeno++;
		if (change_tape()) {
			debug("Change_tape powiedziao eby skoczy");
			koniec_backupu();
		}
	}
}

void do_write() {
	char *tagbuf = NULL;
	int taglen;
	char *blockbuf = NULL;
	int r;

	if (!tagbuf) tagbuf = (char *)malloc(blocksize);
	if (!tagbuf) { perror("malloc"); abort(); }
	
	while (1) {
		open_tape_dev();
		check_drive_mode();
		if (tag_tapes) {
			debug("Taguj tam");
			if (!id) id = (char*)strdup(losuj_id());
			taglen = set_backup_id(tagbuf);
			r = write_block(tagbuf, taglen);
			if (!r)
				error("Nie zmieci si tag pocztku backupu");
			write_eof();
		}
		blockbuf = write_tape(blockbuf);
		if (blockbuf == NULL) {
			write_eof();
			// koniec danych do zapisania
			if (tag_end) {
				taglen = set_backup_end(tagbuf);
				r = write_block(tagbuf, taglen);
				if (!r) {
					char *tagbuftemp;
					int taglentemp;
					warning("Backup si zmieci, ale znacznik koca ju nie.");
					tapeno++;
					if (max_tapes && (tapeno > max_tapes))
						error("Koniec tam");
					close_tape_dev();
					tape_stats();
					change_tape();
					open_tape_dev();
					if (!tagbuftemp) tagbuftemp = (char *)malloc(blocksize);
					if (!tagbuftemp) { perror("malloc"); abort(); }
					debug("Taguj tam");
					taglentemp = set_backup_id(tagbuftemp);
					r = write_block(tagbuftemp, taglentemp);
					if (!r)
						error("Nie zmieci si tag pocztku na nowej tamie");
					free(tagbuftemp);
					write_eof();
					r = write_block(tagbuf, taglen);
					if (!r)
						error("Nie zmieci si znacznik koca tu za znacznikiem pocztku");
				}
			}
			close_tape_dev();
			koniec_backupu();
		}
		close_tape_dev();
		if (max_tapes && (tapeno >= max_tapes)) {
			debug("Osignity limit tam");
			koniec_backupu();
		}
		tape_stats();
		tapeno++;
		change_tape();
	}
}
